
#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com"                           

#property indicator_separate_window
#property indicator_buffers    7
#property indicator_color1     Red
#property indicator_color2     Lime
#property indicator_color3     DodgerBlue
#property indicator_color4     Coral 
#property indicator_color5     DeepSkyBlue
#property indicator_color6     PaleVioletRed
#property indicator_color7     Gold
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_style5     STYLE_DOT
#property indicator_style6     STYLE_DOT
#property indicator_style7     STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[], double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern double Length1                = 50;
extern double Length2                = 10;
extern double Length3                = 10;
extern double Phase                  = 0.0;
extern bool   SmoothDouble           = false;
extern int    DzLookBackBars         = 70;
extern double DzStartBuyProbability  = 0.01;
extern double DzStartSellProbability = 0.01;

extern bool   alertsOn               = true;
extern bool   alertsOnDzZeroCross    = true;
extern bool   alertsOnSignalCross    = true;
extern bool   alertsOnSlope          = true;
extern bool   alertsOnCurrent        = true;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsNotify           = false;
extern bool   alertsEmail            = false;
 
extern bool   arrowsVisible          = false;
extern bool   arrowsOnDzZeroCross    = true;
extern bool   arrowsOnSignalCross    = true;
extern bool   arrowsOnSlope          = true;
extern string arrowsIdentifier       = "dzblau eco";
extern double arrowsUpperGap         = 1.0;
extern double arrowsLowerGap         = 1.0;
extern color  arrowsUpColor          = LimeGreen;
extern color  arrowsDnColor          = Red;
extern int    arrowsUpCode           = 241;
extern int    arrowsDnCode           = 242;


//
//
//
//
//

double eco[];
double Upa[];
double Dna[];
double signal[];
double sli[];
double bli[];
double zli[];
double slope[];
double trend[];
double cross[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,Dna);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Upa);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,eco);
   SetIndexBuffer(3,signal);
   SetIndexBuffer(4,bli);
   SetIndexBuffer(5,sli);
   SetIndexBuffer(6,zli);
   SetIndexBuffer(7,slope);
   SetIndexBuffer(8,trend);
   SetIndexBuffer(9,cross);
   IndicatorShortName("Dynamic zone Blau Eco on jurik ("+DoubleToStr(Length1,1)+","+DoubleToStr(Length2,1)+","+DoubleToStr(Length3,1)+")");   
return(0);
}

int deinit()
{
   deleteArrows();   
return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (int i = limit; i >= 0; i--)
   { 
      double co = iDSmooth(iDSmooth(Close[i]- Open[i],Length1,Phase,SmoothDouble,i, 0),Length2,Phase,SmoothDouble,i,20);
      double hl = iDSmooth(iDSmooth(High[i] - Low[i], Length1,Phase,SmoothDouble,i,40),Length2,Phase,SmoothDouble,i,60);
         
            if (hl!=0)
                  eco[i] = 100.0*co/hl;
            else  eco[i] = 0;                 
            
            signal[i] = iDSmooth(eco[i],Length3,Phase,SmoothDouble,i,80);
            bli[i]    = dzBuyP (eco, DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.0001);
            sli[i]    = dzSellP(eco, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
            zli[i]    = dzSellP(eco, 0.5,                    DzLookBackBars, Bars, i, 0.0001);

            //
            //
            //
            //
            //
            
            Dna[i] = EMPTY_VALUE;
            Upa[i] = EMPTY_VALUE;             
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
            cross[i] = cross[i+1];
               if (eco[i] > zli[i])    trend[i] = 1;
               if (eco[i] < zli[i])    trend[i] =-1;
               if (eco[i] > eco[i+1])  slope[i] = 1;
               if (eco[i] < eco[i+1])  slope[i] =-1;
               if (eco[i] > signal[i]) cross[i] = 1;
               if (eco[i] < signal[i]) cross[i] =-1;         
               if (trend[i] == 1) Upa[i] = eco[i];
               if (trend[i] ==-1) Dna[i] = eco[i];
               manageArrow(i);         
      }
      manageAlerts();
return(0);
}   

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][100];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

 void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":3:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnDzZeroCross && trend[i] != trend[i+1])
      {
         if (trend[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,false);
         if (trend[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode, true);
      } 
      if (arrowsOnSignalCross && cross[i] != cross[i+1])
      {
         if (cross[i] == 1) drawArrow("2",1,i,arrowsUpColor,arrowsUpCode,false);
         if (cross[i] ==-1) drawArrow("2",1,i,arrowsDnColor,arrowsDnCode, true);
      } 
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow("3",1.5,i,arrowsUpColor,arrowsUpCode,false);
         if (slope[i] ==-1) drawArrow("3",1.5,i,arrowsDnColor,arrowsDnCode, true);
      }                                       
   }         
}             

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnDzZeroCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(time1,mess1,whichBar," crossing dynamic zero line up ");
            if (trend[whichBar] ==-1) doAlert(time1,mess1,whichBar," crossing dynamic zero line down ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && cross[whichBar] != cross[whichBar+1])
         {
            if (cross[whichBar] == 1) doAlert(time2,mess2,whichBar," crossing signal line up ");
            if (cross[whichBar] ==-1) doAlert(time2,mess2,whichBar," crossing signal line down ");
         }
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] == 1) doAlert(time2,mess2,whichBar," sloping up ");
            if (slope[whichBar] ==-1) doAlert(time2,mess2,whichBar," sloping down ");
         }                        
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)," DZ Blau - Eco on jurik ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DZ Blau - Eco on jurik "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}